Index: source/ariba/utility/types/Address.cpp
===================================================================
--- source/ariba/utility/types/Address.cpp	(revision 12775)
+++ source/ariba/utility/types/Address.cpp	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #include "Address.h"
Index: source/ariba/utility/types/Address.h
===================================================================
--- source/ariba/utility/types/Address.h	(revision 12775)
+++ source/ariba/utility/types/Address.h	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #ifndef ADDRESS_H_
Index: source/ariba/utility/types/CMakeLists.txt
===================================================================
--- source/ariba/utility/types/CMakeLists.txt	(revision 12775)
+++ 	(revision )
@@ -1,67 +1,0 @@
-# [License]
-# The Ariba-Underlay Copyright
-#
-# Copyright (c) 2008-2012, Institute of Telematics, UniversitÃ€t Karlsruhe (TH)
-#
-# Institute of Telematics
-# UniversitÃ€t Karlsruhe (TH)
-# Zirkel 2, 76128 Karlsruhe
-# Germany
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions are
-# met:
-#
-# 1. Redistributions of source code must retain the above copyright
-# notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-# notice, this list of conditions and the following disclaimer in the
-# documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE INSTITUTE OF TELEMATICS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
-# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OF TELEMATICS OR
-# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
-# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
-# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
-# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
-# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
-# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
-# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-#
-# The views and conclusions contained in the software and documentation
-# are those of the authors and should not be interpreted as representing
-# official policies, either expressed or implied, of the Institute of
-# Telematics.
-# [License]
-
-add_headers(
-    Address.h
-    Data.hpp
-    Identifier.h
-    LinkID.h
-    Locator.h
-    _namespace.h
-    NodeID.h
-    OverlayParameterSet.h
-    PeerID.h
-    QoSParameterSet.h
-    SecurityParameterSet.h
-    ServiceID.h
-    SpoVNetID.h
-    )
-
-add_sources(
-    Address.cpp
-    Identifier.cpp
-    LinkID.cpp
-    Locator.cpp
-    NodeID.cpp
-    OverlayParameterSet.cpp
-    PeerID.cpp
-    QoSParameterSet.cpp
-    SecurityParameterSet.cpp
-    ServiceID.cpp
-    SpoVNetID.cpp
-    )
Index: source/ariba/utility/types/Data.hpp
===================================================================
--- source/ariba/utility/types/Data.hpp	(revision 12775)
+++ source/ariba/utility/types/Data.hpp	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #include "../serialization/Data.hpp"
Index: source/ariba/utility/types/Identifier.cpp
===================================================================
--- source/ariba/utility/types/Identifier.cpp	(revision 12775)
+++ source/ariba/utility/types/Identifier.cpp	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #include "Identifier.h"
@@ -70,5 +70,5 @@
 
 void Identifier::clearAddress() {
-	for (size_t i = 0; i < array_size; i++)
+	for (int i = 0; i < array_size; i++)
 		key[i] = 0;
 	isUnspec = false;
@@ -77,5 +77,5 @@
 
 bool Identifier::setAddress(string address) {
-	return false;
+	// TODO
 }
 
@@ -204,5 +204,5 @@
 	if (isUnspec) return std::string("<unspec>");
 
-	char temp[250];
+	char temp[80];
 	if (base == 16) {
 		int k = 0;
@@ -238,5 +238,4 @@
 }
 #endif
-	return "<not supported>";
 }
 
@@ -320,9 +319,5 @@
 }
 bool Identifier::operator==(const Identifier& compKey) const {
-
-	if( this->isUnspecified() && compKey.isUnspecified() )
-		return true;
-	else
-		return compareTo(compKey) == 0;
+	return compareTo(compKey) == 0;
 }
 bool Identifier::operator!=(const Identifier& compKey) const {
@@ -601,27 +596,27 @@
 Identifier Identifier::random() {
 	Identifier newKey = ZERO;
-	newKey.clearAddress();
 
 	//as mpn_random has no seeding function
-	// we mess aroung here a little to achive some randomness
-	// using the rand function that _is_ seeded in the
-	// StartupWrapper::initSystem function
-
+	// we mess aroung here a little to achive randomness
 	Identifier keyRandom = ZERO;
 	mpn_random(keyRandom.key, aSize);
-	Identifier keyrnd( rand() );
-	mpn_mul_1( newKey.key, keyRandom.key, aSize, *keyrnd.key );
+	Identifier keyTime( time(NULL) );
+	mpn_mul_1( newKey.key, keyRandom.key, aSize, *keyTime.key );
 
 	newKey.trim();
-	assert(!newKey.isUnspecified());
-
 	return newKey;
 }
 
+
+// README: due to some problems with serialization the keylength
+// was changed to 192 bit! As none of the hashing functions
+// can provide 160 bit output, and we currently don't use any
+// hashing for identifiers in the demo at all ... this is all commented out!!
+
+
+// generate sha1 hash
 Identifier Identifier::sha1(const string& input) {
 	Identifier newKey;
-	newKey.clearAddress();
-	uint8_t temp[40];
-	for (int i=0; i<40; i++) temp[i] = 0;
+	uint8_t temp[20];
 	const char* c_str = input.c_str();
 
@@ -641,6 +636,5 @@
 Identifier Identifier::sha1(const uint8_t* value, size_t length ) {
 	Identifier newKey;
-	uint8_t temp[40];
-	for (int i=0; i<40; i++) temp[i] = 0;
+	uint8_t temp[20];
 
 	CSHA1 sha;
@@ -655,4 +649,6 @@
 }
 
+
+
 // generate a key=2**exponent
 Identifier Identifier::pow2(uint exponent) {
Index: source/ariba/utility/types/Identifier.h
===================================================================
--- source/ariba/utility/types/Identifier.h	(revision 12775)
+++ source/ariba/utility/types/Identifier.h	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #ifndef IDENTIFIER_H_
@@ -42,6 +42,4 @@
 #include <memory>
 #include <string>
-#include <cassert>
-#include <iostream>
 #include <gmp.h>
 #include <boost/cstdint.hpp>
@@ -49,7 +47,4 @@
 #include "ariba/utility/types/Address.h"
 #include "ariba/utility/serialization.h"
-
-// XXX EXPERIMENTAL
-#include "ariba/utility/transport/messages/shared_buffer.hpp"
 
 /**< maximum length of the key */
@@ -72,24 +67,4 @@
 	use_logging_h( Identifier );
 public:
-	
-	// XXX EXPERIMENTAL
-	reboost::shared_buffer_t serialize() const
-	{
-	    Data data = data_serialize(this, DEFAULT_V);
-	    reboost::shared_buffer_t buf(data.getBuffer(), data.getLength() / 8);
-	    
-	    return buf;
-	}
-	
-	reboost::shared_buffer_t deserialize(reboost::shared_buffer_t buff)
-	{
-	    Data dat(const_cast<uint8_t*>(buff.data()), buff.size() * 8);
-	    
-	    size_t len = this->SERIALIZATION_METHOD_NAME(DESERIALIZE, dat) / 8;
-
-	    // return remaining sub-buffer
-	    return buff(len);
-	}
-	
 
 	//-------------------------------------------------------------------------
@@ -592,5 +567,4 @@
 /* serializers */
 sznBeginDefault( ariba::utility::Identifier, X ) {
-
 	// calculate length of key
 	uint16_t len = array_size*sizeof(mp_limb_t);
@@ -603,9 +577,6 @@
 	for (int i=array_size-1; i>=0; i--) X && key[i];
 
-	// when deserializing set unspec flag
-	if (X.isDeserializer()){
-		isUnspec = unspec;
-	}
-
+	// when deserializing reset unspec flag
+	if (X.isDeserializer()) isUnspec = unspec;
 } sznEnd();
 
Index: source/ariba/utility/types/LinkID.cpp
===================================================================
--- source/ariba/utility/types/LinkID.cpp	(revision 12775)
+++ source/ariba/utility/types/LinkID.cpp	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #include "LinkID.h"
Index: source/ariba/utility/types/LinkID.h
===================================================================
--- source/ariba/utility/types/LinkID.h	(revision 12775)
+++ source/ariba/utility/types/LinkID.h	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #ifndef LINKID_H_
Index: source/ariba/utility/types/Locator.cpp
===================================================================
--- source/ariba/utility/types/Locator.cpp	(revision 12775)
+++ source/ariba/utility/types/Locator.cpp	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #include "Locator.h"
Index: source/ariba/utility/types/Locator.h
===================================================================
--- source/ariba/utility/types/Locator.h	(revision 12775)
+++ source/ariba/utility/types/Locator.h	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #ifndef LOCATOR_H_
Index: source/ariba/utility/types/NodeID.cpp
===================================================================
--- source/ariba/utility/types/NodeID.cpp	(revision 12775)
+++ source/ariba/utility/types/NodeID.cpp	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #include "NodeID.h"
Index: source/ariba/utility/types/NodeID.h
===================================================================
--- source/ariba/utility/types/NodeID.h	(revision 12775)
+++ source/ariba/utility/types/NodeID.h	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #ifndef __NODEID_H
Index: source/ariba/utility/types/OverlayParameterSet.cpp
===================================================================
--- source/ariba/utility/types/OverlayParameterSet.cpp	(revision 12775)
+++ source/ariba/utility/types/OverlayParameterSet.cpp	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #include "OverlayParameterSet.h"
@@ -55,5 +55,5 @@
 }
 
-void OverlayParameterSet::setOverlayStructure(OverlayStructure _structure){
+void OverlayParameterSet::getOverlayStructure(OverlayStructure _structure){
 	structure = (uint8_t)_structure;
 }
Index: source/ariba/utility/types/OverlayParameterSet.h
===================================================================
--- source/ariba/utility/types/OverlayParameterSet.h	(revision 12775)
+++ source/ariba/utility/types/OverlayParameterSet.h	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #ifndef OVERLAYPARAMETERSET_H_
@@ -53,13 +53,14 @@
 
 	typedef enum _OverlayStructure {
-		OverlayStructureOneHop   = 0,   // DEPRECATED, DO NOT USE
-		OverlayStructureChord    = 1,
+		OverlayStructureOneHop   = 1,
+		OverlayStructureChord    = 2,
+		OverlayStructureKademlia = 3,
 	} OverlayStructure;
 
-	OverlayParameterSet(OverlayStructure _structure = OverlayStructureChord);
+	OverlayParameterSet(OverlayStructure _structure = OverlayStructureOneHop);
 	virtual ~OverlayParameterSet();
 
 	OverlayStructure getOverlayStructure() const;
-	void setOverlayStructure( OverlayStructure _structure );
+	void getOverlayStructure( OverlayStructure _structure );
 
 private:
Index: source/ariba/utility/types/PeerID.cpp
===================================================================
--- source/ariba/utility/types/PeerID.cpp	(revision 12775)
+++ 	(revision )
@@ -1,55 +1,0 @@
-// [License]
-// The Ariba-Underlay Copyright
-//
-// Copyright (c) 2008-2009, Institute of Telematics, UniversitÃ€t Karlsruhe (TH)
-//
-// Institute of Telematics
-// UniversitÃ€t Karlsruhe (TH)
-// Zirkel 2, 76128 Karlsruhe
-// Germany
-//
-// Redistribution and use in source and binary forms, with or without
-// modification, are permitted provided that the following conditions are
-// met:
-//
-// 1. Redistributions of source code must retain the above copyright
-// notice, this list of conditions and the following disclaimer.
-// 2. Redistributions in binary form must reproduce the above copyright
-// notice, this list of conditions and the following disclaimer in the
-// documentation and/or other materials provided with the distribution.
-//
-// THIS SOFTWARE IS PROVIDED BY THE INSTITUTE OF TELEMATICS ``AS IS'' AND
-// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
-// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE ARIBA PROJECT OR
-// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
-// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
-// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
-// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
-// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
-// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
-// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-//
-// The views and conclusions contained in the software and documentation
-// are those of the authors and should not be interpreted as representing
-// official policies, either expressed or implied, of the Institute of
-// Telematics.
-// [License]
-
-#include "PeerID.h"
-
-namespace ariba {
-namespace utility {
-
-const PeerID PeerID::UNSPECIFIED;
-
-PeerID::PeerID() {
-}
-
-PeerID::PeerID(const Identifier& identifier) : Identifier(identifier){
-}
-
-PeerID::~PeerID() {
-}
-
-}} // namespace ariba, common
Index: source/ariba/utility/types/PeerID.h
===================================================================
--- source/ariba/utility/types/PeerID.h	(revision 12775)
+++ 	(revision )
@@ -1,60 +1,0 @@
-// [License]
-// The Ariba-Underlay Copyright
-//
-// Copyright (c) 2008-2009, Institute of Telematics, UniversitÃ€t Karlsruhe (TH)
-//
-// Institute of Telematics
-// UniversitÃ€t Karlsruhe (TH)
-// Zirkel 2, 76128 Karlsruhe
-// Germany
-//
-// Redistribution and use in source and binary forms, with or without
-// modification, are permitted provided that the following conditions are
-// met:
-//
-// 1. Redistributions of source code must retain the above copyright
-// notice, this list of conditions and the following disclaimer.
-// 2. Redistributions in binary form must reproduce the above copyright
-// notice, this list of conditions and the following disclaimer in the
-// documentation and/or other materials provided with the distribution.
-//
-// THIS SOFTWARE IS PROVIDED BY THE INSTITUTE OF TELEMATICS ``AS IS'' AND
-// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
-// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE ARIBA PROJECT OR
-// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
-// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
-// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
-// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
-// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
-// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
-// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-//
-// The views and conclusions contained in the software and documentation
-// are those of the authors and should not be interpreted as representing
-// official policies, either expressed or implied, of the Institute of
-// Telematics.
-// [License]
-
-#ifndef __PEERID_H
-#define __PEERID_H
-
-#include "ariba/utility/types/Identifier.h"
-
-namespace ariba {
-namespace utility {
-
-class PeerID : public Identifier {
-public:
-
-	static const PeerID UNSPECIFIED;
-
-	PeerID();
-	PeerID(const Identifier& identifier);
-	virtual ~PeerID();
-
-};
-
-}} // namespace ariba, common
-
-#endif // __PEERID_H
Index: source/ariba/utility/types/QoSParameterSet.cpp
===================================================================
--- source/ariba/utility/types/QoSParameterSet.cpp	(revision 12775)
+++ source/ariba/utility/types/QoSParameterSet.cpp	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #include "QoSParameterSet.h"
Index: source/ariba/utility/types/QoSParameterSet.h
===================================================================
--- source/ariba/utility/types/QoSParameterSet.h	(revision 12775)
+++ source/ariba/utility/types/QoSParameterSet.h	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #ifndef QOS_PARAMETER_SET_H__
Index: source/ariba/utility/types/SecurityParameterSet.cpp
===================================================================
--- source/ariba/utility/types/SecurityParameterSet.cpp	(revision 12775)
+++ source/ariba/utility/types/SecurityParameterSet.cpp	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #include "SecurityParameterSet.h"
Index: source/ariba/utility/types/SecurityParameterSet.h
===================================================================
--- source/ariba/utility/types/SecurityParameterSet.h	(revision 12775)
+++ source/ariba/utility/types/SecurityParameterSet.h	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #ifndef SECURITY_PARAMETER_SET_H
Index: source/ariba/utility/types/ServiceID.cpp
===================================================================
--- source/ariba/utility/types/ServiceID.cpp	(revision 12775)
+++ source/ariba/utility/types/ServiceID.cpp	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -24,5 +24,5 @@
 // PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE ARIBA PROJECT OR
 // CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
-// EXEMPLARY, OR CONSEQUENTIAL	 DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 // PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 // PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #include "ServiceID.h"
@@ -50,5 +50,5 @@
 }
 
-ServiceID::ServiceID(uint32_t _id) : id( _id ){
+ServiceID::ServiceID(unsigned int _id) : id( _id ){
 }
 
@@ -57,9 +57,4 @@
 
 ServiceID::~ServiceID() {
-}
-
-ServiceID& ServiceID::operator=(const ServiceID &rh) {
-	id = rh.id;
-	return *this;
 }
 
@@ -76,9 +71,5 @@
 }
 
-string ServiceID::toString() const
-{
-    if ( *this == ServiceID::UNSPECIFIED )
-        return "UNSPEC";
-    
+string ServiceID::toString() const {
 	return ariba::utility::Helper::ultos( id );
 }
Index: source/ariba/utility/types/ServiceID.h
===================================================================
--- source/ariba/utility/types/ServiceID.h	(revision 12775)
+++ source/ariba/utility/types/ServiceID.h	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #ifndef SERVICEID_H_
@@ -72,8 +72,7 @@
 	bool operator<(const ServiceID& rh) const;
 	bool operator!=(const ServiceID& rh) const;
-	ServiceID& operator=(const ServiceID &rh);
 
 	inline bool isUnspecified() const {
-		return (id==~(uint32_t)0);
+		return (id==~0);
 	}
 
Index: source/ariba/utility/types/SpoVNetID.cpp
===================================================================
--- source/ariba/utility/types/SpoVNetID.cpp	(revision 12775)
+++ source/ariba/utility/types/SpoVNetID.cpp	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #include "SpoVNetID.h"
Index: source/ariba/utility/types/SpoVNetID.h
===================================================================
--- source/ariba/utility/types/SpoVNetID.h	(revision 12775)
+++ source/ariba/utility/types/SpoVNetID.h	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #ifndef SPOVNETID_H_
Index: source/ariba/utility/types/_namespace.h
===================================================================
--- source/ariba/utility/types/_namespace.h	(revision 12775)
+++ source/ariba/utility/types/_namespace.h	(revision 2378)
@@ -1,3 +1,3 @@
-// [License]
+// [Licence]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [License]
+// [Licence]
 
 #undef NAMESPACE_BEGIN