Index: source/ariba/utility/types/Address.cpp
===================================================================
--- source/ariba/utility/types/Address.cpp	(revision 2801)
+++ source/ariba/utility/types/Address.cpp	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #include "Address.h"
Index: source/ariba/utility/types/Address.h
===================================================================
--- source/ariba/utility/types/Address.h	(revision 2801)
+++ source/ariba/utility/types/Address.h	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #ifndef ADDRESS_H_
Index: source/ariba/utility/types/Data.hpp
===================================================================
--- source/ariba/utility/types/Data.hpp	(revision 2801)
+++ source/ariba/utility/types/Data.hpp	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #include "../serialization/Data.hpp"
Index: source/ariba/utility/types/Identifier.cpp
===================================================================
--- source/ariba/utility/types/Identifier.cpp	(revision 2801)
+++ source/ariba/utility/types/Identifier.cpp	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #include "Identifier.h"
Index: source/ariba/utility/types/Identifier.h
===================================================================
--- source/ariba/utility/types/Identifier.h	(revision 2801)
+++ source/ariba/utility/types/Identifier.h	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #ifndef IDENTIFIER_H_
Index: source/ariba/utility/types/LinkID.cpp
===================================================================
--- source/ariba/utility/types/LinkID.cpp	(revision 2801)
+++ source/ariba/utility/types/LinkID.cpp	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #include "LinkID.h"
Index: source/ariba/utility/types/LinkID.h
===================================================================
--- source/ariba/utility/types/LinkID.h	(revision 2801)
+++ source/ariba/utility/types/LinkID.h	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #ifndef LINKID_H_
Index: source/ariba/utility/types/Locator.cpp
===================================================================
--- source/ariba/utility/types/Locator.cpp	(revision 2801)
+++ source/ariba/utility/types/Locator.cpp	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #include "Locator.h"
Index: source/ariba/utility/types/Locator.h
===================================================================
--- source/ariba/utility/types/Locator.h	(revision 2801)
+++ source/ariba/utility/types/Locator.h	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #ifndef LOCATOR_H_
Index: source/ariba/utility/types/NodeID.cpp
===================================================================
--- source/ariba/utility/types/NodeID.cpp	(revision 2801)
+++ source/ariba/utility/types/NodeID.cpp	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #include "NodeID.h"
Index: source/ariba/utility/types/NodeID.h
===================================================================
--- source/ariba/utility/types/NodeID.h	(revision 2801)
+++ source/ariba/utility/types/NodeID.h	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #ifndef __NODEID_H
Index: source/ariba/utility/types/OverlayParameterSet.cpp
===================================================================
--- source/ariba/utility/types/OverlayParameterSet.cpp	(revision 2801)
+++ source/ariba/utility/types/OverlayParameterSet.cpp	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #include "OverlayParameterSet.h"
Index: source/ariba/utility/types/OverlayParameterSet.h
===================================================================
--- source/ariba/utility/types/OverlayParameterSet.h	(revision 2801)
+++ source/ariba/utility/types/OverlayParameterSet.h	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #ifndef OVERLAYPARAMETERSET_H_
@@ -53,10 +53,10 @@
 
 	typedef enum _OverlayStructure {
-		OverlayStructureOneHop   = 1,
-		OverlayStructureChord    = 2,
-		OverlayStructureKademlia = 3,
+		OverlayStructureOneHop   = 0,
+		OverlayStructureChord    = 1,
+		OverlayStructureKademlia = 2,
 	} OverlayStructure;
 
-	OverlayParameterSet(OverlayStructure _structure = OverlayStructureOneHop);
+	OverlayParameterSet(OverlayStructure _structure = OverlayStructureChord);
 	virtual ~OverlayParameterSet();
 
Index: source/ariba/utility/types/QoSParameterSet.cpp
===================================================================
--- source/ariba/utility/types/QoSParameterSet.cpp	(revision 2801)
+++ source/ariba/utility/types/QoSParameterSet.cpp	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #include "QoSParameterSet.h"
Index: source/ariba/utility/types/QoSParameterSet.h
===================================================================
--- source/ariba/utility/types/QoSParameterSet.h	(revision 2801)
+++ source/ariba/utility/types/QoSParameterSet.h	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #ifndef QOS_PARAMETER_SET_H__
Index: source/ariba/utility/types/SecurityParameterSet.cpp
===================================================================
--- source/ariba/utility/types/SecurityParameterSet.cpp	(revision 2801)
+++ source/ariba/utility/types/SecurityParameterSet.cpp	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #include "SecurityParameterSet.h"
Index: source/ariba/utility/types/SecurityParameterSet.h
===================================================================
--- source/ariba/utility/types/SecurityParameterSet.h	(revision 2801)
+++ source/ariba/utility/types/SecurityParameterSet.h	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #ifndef SECURITY_PARAMETER_SET_H
Index: source/ariba/utility/types/ServiceID.cpp
===================================================================
--- source/ariba/utility/types/ServiceID.cpp	(revision 2801)
+++ source/ariba/utility/types/ServiceID.cpp	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #include "ServiceID.h"
Index: source/ariba/utility/types/ServiceID.h
===================================================================
--- source/ariba/utility/types/ServiceID.h	(revision 2801)
+++ source/ariba/utility/types/ServiceID.h	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #ifndef SERVICEID_H_
Index: source/ariba/utility/types/SpoVNetID.cpp
===================================================================
--- source/ariba/utility/types/SpoVNetID.cpp	(revision 2801)
+++ source/ariba/utility/types/SpoVNetID.cpp	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #include "SpoVNetID.h"
Index: source/ariba/utility/types/SpoVNetID.h
===================================================================
--- source/ariba/utility/types/SpoVNetID.h	(revision 2801)
+++ source/ariba/utility/types/SpoVNetID.h	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #ifndef SPOVNETID_H_
Index: source/ariba/utility/types/_namespace.h
===================================================================
--- source/ariba/utility/types/_namespace.h	(revision 2801)
+++ source/ariba/utility/types/_namespace.h	(revision 3690)
@@ -1,3 +1,3 @@
-// [Licence]
+// [License]
 // The Ariba-Underlay Copyright
 //
@@ -35,5 +35,5 @@
 // official policies, either expressed or implied, of the Institute of
 // Telematics.
-// [Licence]
+// [License]
 
 #undef NAMESPACE_BEGIN